package com.eco.plugin.xxxx.xxxx.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xxxx.xxxx.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "clientId", name = "应用id", description = "应用id", status = Status.SHOW)
    private Conf<String> clientId = Holders.simple("xxxx");

    @Identifier(value = "secret", name = "密钥", description = "密钥", status = Status.SHOW)
    private Conf<String> secret = Holders.simple("xxxx");

    @Identifier(value = "index", name = "帆软首页", description = "帆软首页", status = Status.SHOW)
    private Conf<String> index = Holders.simple("http://localhost:8075/webroot/decision");

    @Identifier(value = "authUrl", name = "获取授权码接口", description = "获取授权码接口", status = Status.SHOW)
    private Conf<String> authUrl = Holders.simple("https://xxxx/connect/authorize");

    @Identifier(value = "logoutUrl", name = "登出接口", description = "登出接口", status = Status.SHOW)
    private Conf<String> logoutUrl = Holders.simple("https://xxxx/connect/endsession");

    @Identifier(value = "redirecturl", name = "登出跳转接口", description = "登出跳转接口", status = Status.SHOW)
    private Conf<String> redirecturl = Holders.simple("http://localhost:8075/webroot/decision");

    @Identifier(value = "userinfo", name = "用户同步接口", description = "用户同步接口", status = Status.SHOW)
    private Conf<String> userinfo = Holders.simple("https://xxxx/api/Users/SyncUsers");

    public String getUserinfo() {
        return userinfo.get();
    }

    public void setUserinfo(String url) {
        this.userinfo.set(url);
    }

    public String getClientId() {
        return clientId.get();
    }

    public void setClientId(String url) {
        this.clientId.set(url);
    }

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String url) {
        this.secret.set(url);
    }

    public String getAuthUrl() {
        return authUrl.get();
    }

    public void setAuthUrl(String url) {
        this.authUrl.set(url);
    }

    public String getLogoutUrl() {
        return logoutUrl.get();
    }

    public void setLogoutUrl(String url) {
        this.logoutUrl.set(url);
    }

    public String getIndex() {
        return index.get();
    }

    public void setIndex(String url) {
        this.index.set(url);
    }

    public String getRedirecturl() {
        return redirecturl.get();
    }

    public void setRedirecturl(String url) {
        this.index.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
